/*<---------------------------------------------------------------------->*/
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include "resource.h"
#include "ToolTips.h"

#define SCRIPT	50
#define BINARY	51
#define INIT	33
#define END		34
#define YES     35
#define NO      36

#define LOCK	40
#define UNLOCK	41

#define OR		10
#define XOR		11
#define SHL		12	
#define SHR		13
#define ROL		14
#define ROR		15
#define IDIV	16
#define IMUL	17
#define TEST	18
#define CMP		19
#define	ADD		20
#define SUB		21
#define AND		22
#define NOT		23
/*<---------------------------------------------------------------------->*/
/* Definizione delle variabili statiche*/
CHAR RegEax[9],RegEbx[9],RegEcx[9],RegEdx[9],RegEdi[9],RegEsi[9],RegAux1[9],RegAux2[9],RegRecived[9]; //Gli otto registri possono contebere al pi 8 byte
DWORD  RegEaxD,RegEbxD,RegEcxD,RegEdxD,RegEdiD,RegEsiD,RegAux1D,RegAux2D;//Dword effettivo nel registro
DWORD RegFlag;

BOOL CheckEax,CheckEbx,CheckEcx,CheckEdx,CheckEdi,CheckEsi,CheckAux1,CheckAux2;//Verifica i registri attivi
UINT Memo;

DWORD  RegEaxDM1,RegEbxDM1,RegEcxDM1,RegEdxDM1,RegEdiDM1,RegEsiDM1,RegAux1DM1,RegAux2DM1,RegRecivedDM1;
DWORD  RegEaxDM2,RegEbxDM2,RegEcxDM2,RegEdxDM2,RegEdiDM2,RegEsiDM2,RegAux1DM2,RegAux2DM2,RegRecivedDM2;
DWORD  RegEaxDM3,RegEbxDM3,RegEcxDM3,RegEdxDM3,RegEdiDM3,RegEsiDM3,RegAux1DM3,RegAux2DM3,RegRecivedDM3;
DWORD  RegEaxDM4,RegEbxDM4,RegEcxDM4,RegEdxDM4,RegEdiDM4,RegEsiDM4,RegAux1DM4,RegAux2DM4,RegRecivedDM4;

extern BYTE RegEaxM1[9]="0",RegEbxM1[9]="0",RegEcxM1[9]="0",RegEdxM1[9]="0",RegEdiM1[9]="0",RegEsiM1[9]="0",RegAux1M1[9]="0",RegAux2M1[9]="0",RegRecivedM1[9]="0";
extern BYTE RegEaxM2[9]="0",RegEbxM2[9]="0",RegEcxM2[9]="0",RegEdxM2[9]="0",RegEdiM2[9]="0",RegEsiM2[9]="0",RegAux1M2[9]="0",RegAux2M2[9]="0",RegRecivedM2[9]="0";
extern BYTE RegEaxM3[9]="0",RegEbxM3[9]="0",RegEcxM3[9]="0",RegEdxM3[9]="0",RegEdiM3[9]="0",RegEsiM3[9]="0",RegAux1M3[9]="0",RegAux2M3[9]="0",RegRecivedM3[9]="0";
extern BYTE RegEaxM4[9]="0",RegEbxM4[9]="0",RegEcxM4[9]="0",RegEdxM4[9]="0",RegEdiM4[9]="0",RegEsiM4[9]="0",RegAux1M4[9]="0",RegAux2M4[9]="0",RegRecivedM4[9]="0";

HBITMAP hbmBall;
HINSTANCE hinstDll;

extern HWND g_hwndDlg;
extern HINSTANCE g_hinst;

HWND hwndDialog,hwndAbout;
HWND SendHwnd;

DWORD RegAppoggio;
DWORD Resource=UNLOCK;


PROCESS_INFORMATION     Proc_Info_Bin,Proc_Info_Scr;

UINT WM_REQUEST,WM_OPERATOR;
/*<---------------------------------------------------------------------->*/

BOOL VerificaErrori(int NumeroValNelRegistro,BYTE Reg[8]);//Sottoverifica
int QuantiQualiSonoChecked(void);//Verifica quanti registri sono checked e marca le variabili bool con 1 se sono checked
BOOL VerificaErroriRegistri(void); //Verifica se nei valori dei registri ci sono degli errori
static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL DumpaTuttoVerificaErroriRegistri(int Flag);
static BOOL CALLBACK DialogFunc1(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);
void SetFlag(int Flag);
void Convert(BYTE Reg[33]);
void CreateChildProcess(int What) ;
static BOOL CALLBACK DialogFunc3(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL ExecuteOperation(int Service);


/*<---------------------------------------------------------------------->*/
void (APIENTRY *pfnOrProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);//Or Procedure
void (APIENTRY *pfnXorProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnShlProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnShrProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnRolProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnRorProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnIdivProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnImulProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnAddProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnSubProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnTestProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnCmpProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);
void (APIENTRY *pfnNotProcedure)(DWORD Reg1,DWORD RegF);
void (APIENTRY *pfnAndProcedure)(DWORD Reg1,DWORD Reg2,DWORD RegF);

/*
Win main just registers a class of the same type that the dialog class, and
then calls DialogBox. Then it exits. The return value is the return value of
the dialog procedure.
*/

int APIENTRY WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wc;

	memset(&wc,0,sizeof(wc));
	wc.lpfnWndProc = DefDlgProc;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hinst;
	g_hinst=hinst;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszClassName = "calcextende";
	RegisterClass(&wc);
	
	return DialogBox(hinst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC) DialogFunc);
	 
}

/*
You should add your initialization code here. This function will be called
when the dialog box receives the WM_INITDIALOG message.
*/
static int InitializeApp(HWND hDlg,WPARAM wParam, LPARAM lParam)
{
	HMENU Menu;

	g_hwndDlg=hDlg;
	hwndDialog=hDlg;
	
	hinstDll=LoadLibrary("c:\\windows\\calcdll.dll");
	pfnOrProcedure=GetProcAddress(hinstDll,"OrProcedure");
	pfnXorProcedure=GetProcAddress(hinstDll,"XorProcedure");
	pfnShlProcedure=GetProcAddress(hinstDll,"ShlProcedure");
	pfnShrProcedure=GetProcAddress(hinstDll,"ShrProcedure");
	pfnRolProcedure=GetProcAddress(hinstDll,"RolProcedure");
	pfnRorProcedure=GetProcAddress(hinstDll,"RorProcedure");
	pfnIdivProcedure=GetProcAddress(hinstDll,"IdivProcedure");
	pfnImulProcedure=GetProcAddress(hinstDll,"ImulProcedure");
	pfnTestProcedure=GetProcAddress(hinstDll,"TestProcedure");
	pfnCmpProcedure=GetProcAddress(hinstDll,"CmpProcedure");
	pfnAndProcedure=GetProcAddress(hinstDll,"AndProcedure");
	pfnNotProcedure=GetProcAddress(hinstDll,"NotProcedure");
	pfnAddProcedure=GetProcAddress(hinstDll,"AddProcedure");
	pfnSubProcedure=GetProcAddress(hinstDll,"SubProcedure");
	
	
	
	WM_OPERATOR=RegisterWindowMessage("wm_operator");
	WM_REQUEST=RegisterWindowMessage("wm_request");

	DoCreateDialogTooltip();
		
	hbmBall = LoadBitmap(g_hinst,"IDB_BITMAP");
	if(!hbmBall) MessageBox(hDlg, "Load of resource BALLBMP failed.", "Error",MB_OK | MB_ICONEXCLAMATION);
	GetVersion();
	
	Menu=LoadMenu(g_hinst,MAKEINTRESOURCE(IDR_MENU1));
	SetMenu(hDlg,Menu);
	return 1;
}

/*
This is the main function for the dialog. It handles all messages. Do what your
application needs to do here.
*/
static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{UINT check;BOOL verifica;

	if (msg==WM_REQUEST) 
	{
		if (lParam==YES) 
		{
			Resource=LOCK;
			MessageBoxA(hwndDlg,"Accepted","Connect",MB_OK);
		}
		if (lParam==NO) 
		{
			MessageBoxA(hwndDlg,"Refused","Connect",MB_OK);
		}
		if (lParam==END) 
		{
			if (wParam==SendHwnd) 
			{
				Resource=UNLOCK;
				MessageBoxA(hwndDlg,"Cancelled","Connect",MB_OK);
			}
			else SendMessage(wParam,WM_REQUEST,hwndDialog,NO);
		}
	
		if (lParam==INIT) 
		{
			if (Resource==UNLOCK)
			{
				Resource=LOCK;
				SendHwnd=wParam;
				MessageBoxA(hwndDlg,"Request","Connect",MB_OK);
			}
			else SendMessage(wParam,WM_REQUEST,hwndDialog,NO);
		}
	}

	if (msg==WM_OPERATOR)
	{
		if (Resource==LOCK)
		{
			if (wParam==SendHwnd)
			{
				wsprintf(RegRecived,"%X",lParam);
				SetDlgItemText(hwndDlg,IDREGRECIVED,RegRecived);
			}
			else SendMessage(wParam,WM_REQUEST,hwndDialog,NO);
		}
		else SendMessage(wParam,WM_REQUEST,hwndDialog,NO);
	}
	
	
	switch (msg) {
	/* This message means the dialog is started but not yet visible.
	   Do All initializations here
        */
	case WM_INITDIALOG:
		InitializeApp(hwndDlg,wParam,lParam);
		return TRUE;
	
    case WM_NOTIFY:
		OnWMNotify(lParam);
		return TRUE;   
	
	case WM_COMMAND:
		switch (LOWORD(wParam)) {

			case M_ABOUT:
				hwndAbout=DialogBox(g_hinst, MAKEINTRESOURCE(IDD_DIALOG2), NULL, (DLGPROC) DialogFunc1);
				return 1;
			
			case M_BINARY:
				CreateChildProcess(BINARY) ;
				return 1;
			
			case M_SCRIPT:
				CreateChildProcess(SCRIPT) ;
				return 1;
			
			case IDOR:
			ExecuteOperation(OR);
			return 1;
			
			case IDADD:
			ExecuteOperation(ADD);
			return 1;
		
			case IDSUB:
				ExecuteOperation(SUB);
			return 1;

			case IDXOR:
				ExecuteOperation(XOR);
			return 1;

			case IDSHL:
				ExecuteOperation(SHL);
			return 1;


			case IDSHR:
				ExecuteOperation(SHR);
			return 1;

			case IDROL:
				ExecuteOperation(ROL);
			return 1;

			case IDROR:
				ExecuteOperation(ROR);
			return 1;

			case IDAND:
				ExecuteOperation(AND);
			return 1;
			
			case IDNOT:
				ExecuteOperation(NOT);
			return 1;

			case IDIDIV:
				ExecuteOperation(IDIV);
			return 1;

			case IDIMUL:
				ExecuteOperation(IMUL);
			return 1;
			
			case IDTEST:
				ExecuteOperation(TEST);
			return 1;
			
			case IDCMP:
				ExecuteOperation(CMP);
			return 1;
			
			case IDRESET:
				{
					if (Resource==LOCK)  
					{
						
						SendMessage(SendHwnd,WM_REQUEST,hwndDlg,END);
						SendHwnd=0;
					}
				}return 1;	
			
			case IDSENDREQUESTBV:
				{
					SendHwnd=FindWindow("#32770","BinaryViewer by Guzura");//becco l'handle della finestra
					if (SendHwnd==NULL) MessageBoxA(hwndDlg,"BinaryViewer non caricato","Error 6",MB_OK);
					else MessageBoxA(hwndDlg,"BinaryViewer caricato","Ok",MB_OK);

					 SendMessage(SendHwnd,WM_REQUEST,hwndDlg,INIT);
				}return 1;					
			
			case IDCLOSEBINARY:
				{
					if (Resource==LOCK)  
					{
						
						SendMessage(SendHwnd,WM_REQUEST,hwndDlg,END);
						SendHwnd=0;
					}
				}return 1;	
			
			case IDSENDBINARY:
				{
					if (Resource==LOCK){
					

						check=QuantiQualiSonoChecked();
					 	if (check==0) MessageBoxA(hwndDlg,"Checkkare l'operando da spedire","Error 3",MB_OK);
					 	if (check>=2) MessageBoxA(hwndDlg,"Checkkare solo l'operando\nche si vuole utilizzare","Error 5",MB_OK);
						else
							{
								verifica=VerificaErroriRegistri();
								if (verifica==1) 
								{
									if (CheckEax==1) SendMessage(SendHwnd,WM_OPERATOR,hwndDlg,RegEaxD);
									if (CheckEbx==1) SendMessage(SendHwnd,WM_OPERATOR,hwndDlg,RegEbxD);
									if (CheckEcx==1) SendMessage(SendHwnd,WM_OPERATOR,hwndDlg,RegEcxD);
									if (CheckEdx==1) SendMessage(SendHwnd,WM_OPERATOR,hwndDlg,RegEdxD);
									if (CheckEdi==1) SendMessage(SendHwnd,WM_OPERATOR,hwndDlg,RegEdiD);
									if (CheckEsi==1) SendMessage(SendHwnd,WM_OPERATOR,hwndDlg,RegEsiD);
									if (CheckAux1==1) SendMessage(SendHwnd,WM_OPERATOR,hwndDlg,RegAux1D);
									if (CheckAux2==1) SendMessage(SendHwnd,WM_OPERATOR,hwndDlg,RegAux2D);
									
								}
							}
						
				}
				}
				return 1;
			




			case IDRECIVED:
				{
					check=QuantiQualiSonoChecked();
					 	if (check==0) MessageBoxA(hwndDlg,"Checkkare l'operando da spedire","Error 3",MB_OK);
					 	if (check>=2) MessageBoxA(hwndDlg,"Checkkare solo l'operando\nche si vuole utilizzare","Error 5",MB_OK);
						else
							{ if  (GetDlgItemText(hwndDlg,IDREGRECIVED,RegRecived,15)<9) {
												switch (Memo) {
													case 1    :SetDlgItemText(hwndDlg,IDEAX,RegRecived);break;
													case 2    :SetDlgItemText(hwndDlg,IDEBX,RegRecived);break;
													case 10   :SetDlgItemText(hwndDlg,IDECX,RegRecived);break;
													case 20   :SetDlgItemText(hwndDlg,IDEDX,RegRecived);break;
													case 100  :SetDlgItemText(hwndDlg,IDEDI,RegRecived);break;
													case 200  :SetDlgItemText(hwndDlg,IDESI,RegRecived);break;
													case 1000 :SetDlgItemText(hwndDlg,IDAUX1,RegRecived);break;
													case 2000 :SetDlgItemText(hwndDlg,IDAUX2,RegRecived);break;
													default   : MessageBoxA(hwndDlg,"Errore spedizione","Error 3",MB_OK);break;
													          }					   }

								else 	MessageBoxA(hwndDlg,"Il valore eccede la Dword","Error 3",MB_OK);
							}
				}
				return 1;

			case IDM1:
				{
					if (!DumpaTuttoVerificaErroriRegistri(1)) MessageBoxA(hwndDlg,"Errore in qualche registro","Error 3",MB_OK);
				}
				return 1;


			case IDM2:
				{
					if (!DumpaTuttoVerificaErroriRegistri(2)) MessageBoxA(hwndDlg,"Errore in qualche registro","Error 3",MB_OK);
				}
				return 1;


			case IDM3:
				{
					if (!DumpaTuttoVerificaErroriRegistri(3)) MessageBoxA(hwndDlg,"Errore in qualche registro","Error 3",MB_OK);
				}
				return 1;


			case IDM4:
				{
					if (!DumpaTuttoVerificaErroriRegistri(4)) MessageBoxA(hwndDlg,"Errore in qualche registro","Error 3",MB_OK);
				}
				return 1;

			case IDR1:
				{
					SetDlgItemText(hwndDlg,IDEAX,RegEaxM1);	
					SetDlgItemText(hwndDlg,IDEBX,RegEbxM1);	
					SetDlgItemText(hwndDlg,IDECX,RegEcxM1);
					SetDlgItemText(hwndDlg,IDEDX,RegEdxM1);
					SetDlgItemText(hwndDlg,IDEDI,RegEdiM1);
					SetDlgItemText(hwndDlg,IDESI,RegEsiM1);
					SetDlgItemText(hwndDlg,IDAUX1,RegAux1M1);
					SetDlgItemText(hwndDlg,IDAUX2,RegAux2M1);
					SetDlgItemText(hwndDlg,IDREGRECIVED,RegRecivedM1);
				}
				return 1;


			case IDR2:
				{
					SetDlgItemText(hwndDlg,IDEAX,RegEaxM2);	
					SetDlgItemText(hwndDlg,IDEBX,RegEbxM2);	
					SetDlgItemText(hwndDlg,IDECX,RegEcxM2);
					SetDlgItemText(hwndDlg,IDEDX,RegEdxM2);
					SetDlgItemText(hwndDlg,IDEDI,RegEdiM2);
					SetDlgItemText(hwndDlg,IDESI,RegEsiM2);
					SetDlgItemText(hwndDlg,IDAUX1,RegAux1M2);
					SetDlgItemText(hwndDlg,IDAUX2,RegAux2M2);
					SetDlgItemText(hwndDlg,IDREGRECIVED,RegRecivedM2);
				}
				return 1;


			case IDR3:
				{
					SetDlgItemText(hwndDlg,IDEAX,RegEaxM3);	
					SetDlgItemText(hwndDlg,IDEBX,RegEbxM3);	
					SetDlgItemText(hwndDlg,IDECX,RegEcxM3);
					SetDlgItemText(hwndDlg,IDEDX,RegEdxM3);
					SetDlgItemText(hwndDlg,IDEDI,RegEdiM3);
					SetDlgItemText(hwndDlg,IDESI,RegEsiM3);
					SetDlgItemText(hwndDlg,IDAUX1,RegAux1M3);
					SetDlgItemText(hwndDlg,IDAUX2,RegAux2M3);
					SetDlgItemText(hwndDlg,IDREGRECIVED,RegRecivedM3);	
				}
				return 1;


			case IDR4:
				{
					SetDlgItemText(hwndDlg,IDEAX,RegEaxM4);	
					SetDlgItemText(hwndDlg,IDEBX,RegEbxM4);	
					SetDlgItemText(hwndDlg,IDECX,RegEcxM4);
					SetDlgItemText(hwndDlg,IDEDX,RegEdxM4);
					SetDlgItemText(hwndDlg,IDEDI,RegEdiM4);
					SetDlgItemText(hwndDlg,IDESI,RegEsiM4);
					SetDlgItemText(hwndDlg,IDAUX1,RegAux1M4);
					SetDlgItemText(hwndDlg,IDAUX2,RegAux2M4);
					SetDlgItemText(hwndDlg,IDREGRECIVED,RegRecivedM4);	
				}
				return 1;

			case M_EXIT:
				{
					if (Resource==LOCK) SendMessage(SendHwnd,WM_REQUEST,hwndDialog,END);
					PostMessage(hwndDlg,WM_QUIT,0,0);
				}
				return 1;




	}break;

	case WM_CLOSE:
		if (Resource==LOCK) SendMessage(SendHwnd,WM_REQUEST,hwndDialog,END);
		EndDialog(hwndDlg,0);
		return TRUE;

	}
	return FALSE;
}


/*<---------------------------------------------------------------------->*/

//Verifica se nei valori dei registri ci sono degli errori e controlla solo quelli checkati (al pi due)
BOOL VerificaErroriRegistri(void)
{
	int NumValNelRegistro,verifica=0;
	//Memo=0;
	if (CheckEax==1) //controllo quali registri sono stati checkkati
		{
			NumValNelRegistro=GetDlgItemText(hwndDialog,IDEAX,RegEax,15);
	        verifica=VerificaErrori(NumValNelRegistro,RegEax);
			RegEaxD=RegAppoggio;
			if (verifica==0) return 0;
		}

	if (CheckEbx==1) //controllo quali registri sono stati checkkati
		{
			NumValNelRegistro=GetDlgItemText(hwndDialog,IDEBX,RegEbx,15);
	        verifica=VerificaErrori(NumValNelRegistro,RegEbx);
			RegEbxD=RegAppoggio;
			if (verifica==0) return 0;
		}
	if (CheckEcx==1) //controllo quali registri sono stati checkkati
		{
			NumValNelRegistro=GetDlgItemText(hwndDialog,IDECX,RegEcx,15);
	        verifica=VerificaErrori(NumValNelRegistro,RegEcx);
			RegEcxD=RegAppoggio;
			if (verifica==0) return 0;
		}
	if (CheckEdx==1) //controllo quali registri sono stati checkkati
		{
			NumValNelRegistro=GetDlgItemText(hwndDialog,IDEDX,RegEdx,15);
	        verifica=VerificaErrori(NumValNelRegistro,RegEdx);
			RegEdxD=RegAppoggio;
			if (verifica==0) return 0;
		}
	if (CheckEdi==1) //controllo quali registri sono stati checkkati
		{
			NumValNelRegistro=GetDlgItemText(hwndDialog,IDEDI,RegEdi,15);
	        verifica=VerificaErrori(NumValNelRegistro,RegEdi);
			RegEdiD=RegAppoggio;
			if (verifica==0) return 0;
		}
	if (CheckEsi==1) //controllo quali registri sono stati checkkati
		{
			NumValNelRegistro=GetDlgItemText(hwndDialog,IDESI,RegEsi,15);
	        verifica=VerificaErrori(NumValNelRegistro,RegEsi);
			RegEsiD=RegAppoggio;
			if (verifica==0) return 0;
		}
	if (CheckAux1==1) //controllo quali registri sono stati checkkati
		{
			NumValNelRegistro=GetDlgItemText(hwndDialog,IDAUX1,RegAux1,15);
	        verifica=VerificaErrori(NumValNelRegistro,RegAux1);
			RegAux1D=RegAppoggio;
			if (verifica==0) return 0;
		}
	if (CheckAux2==1) //controllo quali registri sono stati checkkati
		{
			NumValNelRegistro=GetDlgItemText(hwndDialog,IDAUX2,RegAux2,15);
	        verifica=VerificaErrori(NumValNelRegistro,RegAux2);
			RegAux2D=RegAppoggio;
			if (verifica==0) return 0;
		}
	return 1;

}

/*<---------------------------------------------------------------------->*/
//Sottoverifica in base al registro checkato
BOOL VerificaErrori(int NumeroValNelRegistro,BYTE Reg[9])
 {
	int ValoriRicostruzione[8];DWORD RegDlocale;
	BOOL verifica;int counter=0,Potenza16=16,counter1=0,counter2=0,counter3=0;
	ValoriRicostruzione[0]=99;ValoriRicostruzione[1]=99;ValoriRicostruzione[2]=99;ValoriRicostruzione[3]=99;
	ValoriRicostruzione[4]=99;ValoriRicostruzione[5]=99;ValoriRicostruzione[6]=99;ValoriRicostruzione[7]=99;




	if (NumeroValNelRegistro>=9) //Verifica numero dei parametri
		{
			MessageBoxA(hwndDialog,"Il valore nel registro selezionato\neccede in lunghezza","Errore 0",MB_OK);
			return 0;
		}
	if (NumeroValNelRegistro==0) //Verifica numero dei parametri
		{
			MessageBoxA(hwndDialog,"Inserire il valore nel registro selezionato","Errore 1",MB_OK);
			return 0;
		}
	for (counter=0;counter<=NumeroValNelRegistro-1;counter++)//Verifica se sono Hex li confronto tutti
		{
			switch (Reg[counter])
			{
				case 'A': ValoriRicostruzione[counter]=10;break;
				case 'B': ValoriRicostruzione[counter]=11;break;
				case 'C': ValoriRicostruzione[counter]=12;break;
				case 'D': ValoriRicostruzione[counter]=13;break;
				case 'E': ValoriRicostruzione[counter]=14;break;
				case 'F': ValoriRicostruzione[counter]=15;break;
				case 'a': ValoriRicostruzione[counter]=10;break;
				case 'b': ValoriRicostruzione[counter]=11;break;
				case 'c': ValoriRicostruzione[counter]=12;break;
				case 'd': ValoriRicostruzione[counter]=13;break;
				case 'e': ValoriRicostruzione[counter]=14;break;
				case 'f': ValoriRicostruzione[counter]=15;break;
				case '0': ValoriRicostruzione[counter]=0;break;
				case '1': ValoriRicostruzione[counter]=1;break;
				case '2': ValoriRicostruzione[counter]=2;break;
				case '3': ValoriRicostruzione[counter]=3;break;
				case '4': ValoriRicostruzione[counter]=4;break;
				case '5': ValoriRicostruzione[counter]=5;break;
				case '6': ValoriRicostruzione[counter]=6;break;
				case '7': ValoriRicostruzione[counter]=7;break;
				case '8': ValoriRicostruzione[counter]=8;break;
				case '9': ValoriRicostruzione[counter]=9;break;

				default :{
					MessageBoxA(hwndDialog,"Il valore nel registro non  Esadecimale","Errore 2",MB_OK);
					counter=9;
					verifica=0;
					break;};
			}
		}


	if (verifica==0) return 0;
	else
		{//Ciclo di conversione
			for (counter1=0;counter1<8;counter1++)
				{
					switch (ValoriRicostruzione[counter1])
						{
							case 99:break;
							default: counter2++;break;
						}
				}


			--counter2;
			RegDlocale=ValoriRicostruzione[counter2];
			//Vera ricostruzione
			if (counter2!=0) {
								for (counter3=0;counter3<8;counter3++)
									{
										--counter2;
										RegDlocale=RegDlocale+(ValoriRicostruzione[counter2]*Potenza16);
										Potenza16=Potenza16*16;
										if (counter2==0) counter3=8;
									}//Fine ciclo di conversione

							}
			
	
			RegAppoggio=RegDlocale;
			return 1;
		}

}

/*<---------------------------------------------------------------------->*/
/*Verifica quanti e quali registri sono checkati ritorna 0 o >=3 =Errore, 1=uno checked, 2=due checked e marca le variabili globali booleane
con uno (checked) o zero (not checked)*/
int QuantiQualiSonoChecked(void)
{
	int CounterChecked=0;
	Memo=0;
	if (IsDlgButtonChecked(hwndDialog,IDCHECKEAX)==BST_CHECKED)
		{
			CheckEax=1;
			CounterChecked++;
			Memo=1;
		}
	else CheckEax=0;


	if (IsDlgButtonChecked(hwndDialog,IDCHECKEBX)==BST_CHECKED)
		{
			CheckEbx=1;
			CounterChecked++;
			Memo=Memo+2;
		}
	else CheckEbx=0;

	if (IsDlgButtonChecked(hwndDialog,IDCHECKECX)==BST_CHECKED)
		{
			CheckEcx=1;
			CounterChecked++;
			Memo=Memo+10;
		}
	else CheckEcx=0;

	if (IsDlgButtonChecked(hwndDialog,IDCHECKEDX)==BST_CHECKED)
		{
			CheckEdx=1;
			CounterChecked++;
			Memo=Memo+20;
		}
	else CheckEdx=0;

	if (IsDlgButtonChecked(hwndDialog,IDCHECKEDI)==BST_CHECKED)
		{
			CheckEdi=1;
			CounterChecked++;
			Memo=Memo+100;
		}
	else CheckEdi=0;

	if (IsDlgButtonChecked(hwndDialog,IDCHECKESI)==BST_CHECKED)
		{
			CheckEsi=1;
			CounterChecked++;
			Memo=Memo+200;
		}
	else CheckEsi=0;

	if (IsDlgButtonChecked(hwndDialog,IDCHECKAUX1)==BST_CHECKED)
		{
			CheckAux1=1;
			CounterChecked++;
			Memo=Memo+1000;
		}
	else CheckAux1=0;

	if (IsDlgButtonChecked(hwndDialog,IDCHECKAUX2)==BST_CHECKED)
		{
			CheckAux2=1;
			CounterChecked++;
			Memo=Memo+2000;
		}
	else CheckAux2=0;


return CounterChecked;
}

/*<---------------------------------------------------------------------->*/

/*<---------------------------------------------------------------------->*/
//Manda i SendMessage

/*<---------------------------------------------------------------------->*/
BOOL DumpaTuttoVerificaErroriRegistri(int Flag)
{
	int NumValNelRegistro,verifica=0;
			
	NumValNelRegistro=GetDlgItemText(hwndDialog,IDEAX,RegEax,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegEax);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegEaxDM1=RegAppoggio;wsprintf(RegEaxM1,"%X",RegEaxDM1);break;
				case 2: RegEaxDM2=RegAppoggio;wsprintf(RegEaxM2,"%X",RegEaxDM2);break;
				case 3: RegEaxDM3=RegAppoggio;wsprintf(RegEaxM3,"%X",RegEaxDM3);break;
				case 4: RegEaxDM4=RegAppoggio;wsprintf(RegEaxM4,"%X",RegEaxDM4);break;
			}
	
	NumValNelRegistro=GetDlgItemText(hwndDialog,IDEBX,RegEbx,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegEbx);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegEbxDM1=RegAppoggio;wsprintf(RegEbxM1,"%X",RegEbxDM1);break;
				case 2: RegEbxDM2=RegAppoggio;wsprintf(RegEbxM2,"%X",RegEbxDM2);break;
				case 3: RegEbxDM3=RegAppoggio;wsprintf(RegEbxM3,"%X",RegEbxDM3);break;
				case 4: RegEbxDM4=RegAppoggio;wsprintf(RegEbxM4,"%X",RegEbxDM4);break;
			}
	
	NumValNelRegistro=GetDlgItemText(hwndDialog,IDECX,RegEcx,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegEcx);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegEcxDM1=RegAppoggio;wsprintf(RegEcxM1,"%X",RegEcxDM1);break;
				case 2: RegEcxDM2=RegAppoggio;wsprintf(RegEcxM2,"%X",RegEcxDM2);break;
				case 3: RegEcxDM3=RegAppoggio;wsprintf(RegEcxM3,"%X",RegEcxDM3);break;
				case 4: RegEcxDM4=RegAppoggio;wsprintf(RegEcxM4,"%X",RegEcxDM4);break;
			}

	NumValNelRegistro=GetDlgItemText(hwndDialog,IDEDX,RegEdx,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegEdx);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegEdxDM1=RegAppoggio;wsprintf(RegEdxM1,"%X",RegEdxDM1);break;
				case 2: RegEdxDM2=RegAppoggio;wsprintf(RegEdxM2,"%X",RegEdxDM2);break;
				case 3: RegEdxDM3=RegAppoggio;wsprintf(RegEdxM3,"%X",RegEdxDM3);break;
				case 4: RegEdxDM4=RegAppoggio;wsprintf(RegEdxM4,"%X",RegEdxDM4);break;
			}
	
	NumValNelRegistro=GetDlgItemText(hwndDialog,IDEDI,RegEdi,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegEdi);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegEdiDM1=RegAppoggio;wsprintf(RegEdiM1,"%X",RegEdiDM1);break;
				case 2: RegEdiDM2=RegAppoggio;wsprintf(RegEdiM2,"%X",RegEdiDM2);break;
				case 3: RegEdiDM3=RegAppoggio;wsprintf(RegEdiM3,"%X",RegEdiDM3);break;
				case 4: RegEdiDM4=RegAppoggio;wsprintf(RegEdiM4,"%X",RegEdiDM4);break;
			}
	
	NumValNelRegistro=GetDlgItemText(hwndDialog,IDESI,RegEsi,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegEsi);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegEsiDM1=RegAppoggio;wsprintf(RegEsiM1,"%X",RegEsiDM1);break;
				case 2: RegEsiDM2=RegAppoggio;wsprintf(RegEsiM2,"%X",RegEsiDM2);break;
				case 3: RegEsiDM3=RegAppoggio;wsprintf(RegEsiM3,"%X",RegEsiDM3);break;
				case 4: RegEsiDM4=RegAppoggio;wsprintf(RegEsiM4,"%X",RegEsiDM4);break;
			}
	
	NumValNelRegistro=GetDlgItemText(hwndDialog,IDAUX1,RegAux1,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegAux1);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegAux1DM1=RegAppoggio;wsprintf(RegAux1M1,"%X",RegAux1DM1);break;
				case 2: RegAux1DM2=RegAppoggio;wsprintf(RegAux1M2,"%X",RegAux1DM2);break;
				case 3: RegAux1DM3=RegAppoggio;wsprintf(RegAux1M3,"%X",RegAux1DM3);break;
				case 4: RegAux1DM4=RegAppoggio;wsprintf(RegAux1M4,"%X",RegAux1DM4);break;
			}	
	
	NumValNelRegistro=GetDlgItemText(hwndDialog,IDAUX2,RegAux2,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegAux2);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegAux2DM1=RegAppoggio;wsprintf(RegAux2M1,"%X",RegAux2DM1);break;
				case 2: RegAux2DM2=RegAppoggio;wsprintf(RegAux2M2,"%X",RegAux2DM2);break;
				case 3: RegAux2DM3=RegAppoggio;wsprintf(RegAux2M3,"%X",RegAux2DM3);break;
				case 4: RegAux2DM4=RegAppoggio;wsprintf(RegAux2M4,"%X",RegAux2DM4);break;
			}
	
	NumValNelRegistro=GetDlgItemText(hwndDialog,IDREGRECIVED,RegRecived,15);
	if (NumValNelRegistro!=0) verifica=VerificaErrori(NumValNelRegistro,RegRecived);
	else {RegAppoggio=0;verifica=1;}
	if (verifica==0) return 0;
	else switch (Flag)
			{
				case 1: RegRecivedDM1=RegAppoggio;wsprintf(RegRecivedM1,"%X",RegRecivedDM1);break;
				case 2: RegRecivedDM2=RegAppoggio;wsprintf(RegRecivedM2,"%X",RegRecivedDM2);break;
				case 3: RegRecivedDM3=RegAppoggio;wsprintf(RegRecivedM3,"%X",RegRecivedDM3);break;
				case 4: RegRecivedDM4=RegAppoggio;wsprintf(RegRecivedM4,"%X",RegRecivedDM4);break;	
	
			}
	return 1;

}

/*<---------------------------------------------------------------------->*/

static BOOL CALLBACK DialogFunc1(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
		case WM_PAINT:
			if(hbmBall)
				{
					PAINTSTRUCT ps;
					HDC hdcMemory, hdcWindow;
					BITMAP bm;

					hdcWindow = BeginPaint(hwndDlg, &ps);
					hdcMemory = CreateCompatibleDC(hdcWindow);

					SelectObject(hdcMemory, hbmBall);
					GetObject(hbmBall, sizeof(bm), &bm);

					BitBlt(hdcWindow, 0, 0, bm.bmWidth, bm.bmHeight, hdcMemory, 0, 0, SRCCOPY);

						DeleteDC(hdcMemory);
						EndPaint(hwndDlg, &ps);
			} return TRUE;


		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				
				case IDOK1:	
				EndDialog(hwndDlg,0);
				return TRUE;
				}
	
		case WM_CLOSE:
		EndDialog(hwndDlg,0);
		return TRUE;
	
	}			
			
			
			return FALSE;
}

/*<---------------------------------------------------------------------->*/
void SetFlag(int Flag)
{
	BYTE Reg[33]="000000000000000000000000000000000"; 
	
		if (Flag==0) { 
					SetDlgItemText(hwndDialog,IDCARRY,"");
					SetDlgItemText(hwndDialog,IDPARITY,"");
					SetDlgItemText(hwndDialog,IDZERO,"");
					SetDlgItemText(hwndDialog,IDOVERFLOW,"");
					SetDlgItemText(hwndDialog,IDSIGN,"");
					SetDlgItemText(hwndDialog,IDAUXILIARY,"");
					}
	else {
	
	Convert(Reg);
	if (Reg[0]=='1') SetDlgItemText(hwndDialog,IDCARRY,"X");
	if (Reg[2]=='1') SetDlgItemText(hwndDialog,IDPARITY,"X");
	if (Reg[4]=='1') SetDlgItemText(hwndDialog,IDPARITY,"X");
	if (Reg[6]=='1') SetDlgItemText(hwndDialog,IDZERO,"X");
	if (Reg[11]=='1') SetDlgItemText(hwndDialog,IDOVERFLOW,"X");
	if (Reg[7]=='1') SetDlgItemText(hwndDialog,IDSIGN,"X");
	
	}

}
/*<---------------------------------------------------------------------->*/
void Convert(BYTE Reg[33])
{
	int i;
	DWORD a;
	DWORD Resto;
	a=RegFlag;
	
	
	for (i=0;i<=32;i++)
	{
		GetVersion();
		__asm{
			mov eax,a;
			mov ecx,2;
			xor edx,edx;
			div ecx;
			mov Resto,edx;
			mov a,eax;
		}
			if (Resto==0) Reg[i]='0';
			else Reg[i]='1';
	}
	
}
/*<---------------------------------------------------------------------->*/
void CreateChildProcess(int What) 
{
			 char Child[20]="";
             PROCESS_INFORMATION     piProcInfo; 
			 STARTUPINFO             siStartInfo;

if (What==SCRIPT) lstrcpy(Child,"ScriptExecuter.exe");
if (What==BINARY) lstrcpy(Child,"BinaryViewer.exe");
             // Set up members of STARTUPINFO structure.
			 siStartInfo.cb          = sizeof(STARTUPINFO); 
             siStartInfo.lpReserved  = NULL;
             siStartInfo.lpReserved2 = NULL; 
             siStartInfo.cbReserved2 = 0;
             siStartInfo.lpDesktop   = NULL; 
             siStartInfo.dwFlags     = 0;

             // Create the child process.

             CreateProcess(
                 NULL,
                 Child,
                 NULL,           // process security attributes
                 NULL,           // primary thread security attributes
                 0,              // handles are inherited
                 0,              // creation flags
                 NULL,           // use parent's environment
                 NULL,           // use parent's current directory
                 &siStartInfo,   // STARTUPINFO pointer
                 &piProcInfo);   // receives PROCESS_INFORMATION

if (What==SCRIPT) Proc_Info_Bin=piProcInfo;
if (What==BINARY) Proc_Info_Scr=piProcInfo;
}

/*<---------------------------------------------------------------------->*/
BOOL ExecuteOperation(int Service)
{UINT check;BOOL verifica;
	DWORD RegAppoggio1D,RegAppoggio2D,RegAppoggioFlag;
	check=QuantiQualiSonoChecked();
	if (check==0) 
	{
		MessageBoxA(hwndDialog,"Checkkare gli operandi","Error 3",MB_OK);
		return 0;
	}
	if (check==1 && Service!=NOT) 
	{
		MessageBoxA(hwndDialog,"Checkkare un'altro operando","Error 4",MB_OK);
		return 0;
	}
	if (check>=3) 
	{
		MessageBoxA(hwndDialog,"Checkkare solo gli operandi\nche si vogliono utilizzare","Error 5",MB_OK);
			return 0;
	}			
	if (check==2 || (check==1 && Service==NOT))
	{
		if (check==2 && Service==NOT) 
			{
			MessageBox(hwndDialog,"Checkkare solo un operando","Error 5",MB_OK);
			return 0;
			}
		else 
		{
			verifica=VerificaErroriRegistri();
			if (verifica==1) 
			{
			switch (Memo)	{
								case 3    :RegAppoggio1D=RegEaxD;RegAppoggio2D=RegEbxD;break;
								case 11   :RegAppoggio1D=RegEaxD;RegAppoggio2D=RegEcxD;break;
								case 21   :RegAppoggio1D=RegEaxD;RegAppoggio2D=RegEdxD;break;
								case 101  :RegAppoggio1D=RegEaxD;RegAppoggio2D=RegEdiD;break;
								case 201  :RegAppoggio1D=RegEaxD;RegAppoggio2D=RegEsiD;break;
								case 1001 :RegAppoggio1D=RegEaxD;RegAppoggio2D=RegAux1D;break;
								case 2001 :RegAppoggio1D=RegEaxD;RegAppoggio2D=RegAux2D;break;
								case 12   :RegAppoggio1D=RegEbxD;RegAppoggio2D=RegEcxD;break;
								case 22   :RegAppoggio1D=RegEbxD;RegAppoggio2D=RegEdxD;break;
								case 102  :RegAppoggio1D=RegEbxD;RegAppoggio2D=RegEdiD;break;
								case 202  :RegAppoggio1D=RegEbxD;RegAppoggio2D=RegEsiD;break;
								case 1002 :RegAppoggio1D=RegEbxD;RegAppoggio2D=RegAux1D;break;
								case 2002 :RegAppoggio1D=RegEbxD;RegAppoggio2D=RegAux2D;break;
								case 30   :RegAppoggio1D=RegEcxD;RegAppoggio2D=RegEdxD;break;
								case 110  :RegAppoggio1D=RegEcxD;RegAppoggio2D=RegEdiD;break;
								case 210  :RegAppoggio1D=RegEcxD;RegAppoggio2D=RegEsiD;break;
								case 1010 :RegAppoggio1D=RegEcxD;RegAppoggio2D=RegAux1D;break;
								case 2010 :RegAppoggio1D=RegEcxD;RegAppoggio2D=RegAux2D;break;
								case 120  :RegAppoggio1D=RegEdxD;RegAppoggio2D=RegEdiD;break;
								case 220  :RegAppoggio1D=RegEdxD;RegAppoggio2D=RegEsiD;break;
								case 1020 :RegAppoggio1D=RegEdxD;RegAppoggio2D=RegAux1D;break;
								case 2020 :RegAppoggio1D=RegEdxD;RegAppoggio2D=RegAux2D;break;
								case 300  :RegAppoggio1D=RegEdiD;RegAppoggio2D=RegEsiD;break;
								case 1100 :RegAppoggio1D=RegEdiD;RegAppoggio2D=RegAux1D;break;
								case 2100 :RegAppoggio1D=RegEdiD;RegAppoggio2D=RegAux2D;break;
								case 1200 :RegAppoggio1D=RegEsiD;RegAppoggio2D=RegAux1D;break;
								case 2200 :RegAppoggio1D=RegEsiD;RegAppoggio2D=RegAux2D;break;
								case 3000 :RegAppoggio1D=RegAux1D;RegAppoggio2D=RegAux2D;break;
								case 1    :RegAppoggio1D=RegEaxD;RegAppoggio2D=0;break;
								case 2    :RegAppoggio1D=RegEbxD;RegAppoggio2D=0;break;
								case 10   :RegAppoggio1D=RegEcxD;RegAppoggio2D=0;break;
								case 20   :RegAppoggio1D=RegEdxD;RegAppoggio2D=0;break;
								case 100  :RegAppoggio1D=RegEdiD;RegAppoggio2D=0;break;
								case 200  :RegAppoggio1D=RegEsiD;RegAppoggio2D=0;break;
								case 1000 :RegAppoggio1D=RegAux1D;RegAppoggio2D=0;break;
								case 2000 :RegAppoggio1D=RegAux2D;RegAppoggio2D=0;break;
													

								default   :
									{
										MessageBoxA(hwndDialog,"ERRORE","Error 8",MB_OK);
										return 0;
									}	break;
							}
		
			switch (Service){
								case OR:pfnOrProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case XOR:pfnXorProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case SHL:pfnShlProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case SHR:pfnShrProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case ROL:pfnRolProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case ROR:pfnRorProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case IDIV:pfnIdivProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case IMUL:pfnImulProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case TEST:pfnTestProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case CMP:pfnCmpProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case NOT:pfnNotProcedure(&RegAppoggio1D,RegAppoggio2D,&RegAppoggioFlag);break;
								case ADD:pfnAddProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case SUB:pfnSubProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;
								case AND:pfnAndProcedure(&RegAppoggio1D,&RegAppoggio2D,&RegAppoggioFlag);break;

								default   :
									{
										MessageBoxA(hwndDialog,"ERRORE","Error 8",MB_OK);
										return 0;
									}	break;
							}		
		
			if (Service==NOT) RegFlag=0;
			else	RegFlag=RegAppoggioFlag;
			
			SetFlag(0);
		
			if (Service!=IDIV && Service!=IMUL)
			{
			switch (Memo)	{
								case 3    :wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);break;
								case 11   :wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);break;
								case 21   :wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);break;
								case 101  :wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);break;
								case 201  :wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);break;
								case 1001 :wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);break;
								case 2001 :wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);break;
								case 12   :wsprintf(RegEbx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEBX,RegEbx);break;
								case 22   :wsprintf(RegEbx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEBX,RegEbx);break;
								case 102  :wsprintf(RegEbx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEBX,RegEbx);break;
								case 202  :wsprintf(RegEbx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEBX,RegEbx);break;
								case 1002 :wsprintf(RegEbx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEBX,RegEbx);break;
								case 2002 :wsprintf(RegEbx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEBX,RegEbx);break;
								case 30   :wsprintf(RegEcx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDECX,RegEcx);break;
								case 110  :wsprintf(RegEcx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDECX,RegEcx);break;
								case 210  :wsprintf(RegEcx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDECX,RegEcx);break;
								case 1010 :wsprintf(RegEcx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDECX,RegEcx);break;
								case 2010 :wsprintf(RegEcx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDECX,RegEcx);break;
								case 120  :wsprintf(RegEdx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDX,RegEdx);break;
								case 220  :wsprintf(RegEdx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDX,RegEdx);break;
								case 1020 :wsprintf(RegEdx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDX,RegEdx);break;
								case 2020 :wsprintf(RegEdx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDX,RegEdx);break;
								case 300  :wsprintf(RegEdi,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDI,RegEdi);break;
								case 1100 :wsprintf(RegEdi,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDI,RegEdi);break;
								case 2100 :wsprintf(RegEdi,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDI,RegEdi);break;
								case 1200 :wsprintf(RegEsi,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDESI,RegEsi);break;
								case 2200 :wsprintf(RegEsi,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDESI,RegEsi);break;
								case 3000 :wsprintf(RegAux1,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDAUX1,RegAux1);break;
								case 1    :wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);break;
								case 2    :wsprintf(RegEbx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEBX,RegEbx);break;
								case 10   :wsprintf(RegEcx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDECX,RegEcx);break;
								case 20   :wsprintf(RegEdx,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDX,RegEdx);break;
								case 100  :wsprintf(RegEdi,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEDI,RegEdi);break;
								case 200  :wsprintf(RegEsi,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDESI,RegEsi);break;
								case 1000 :wsprintf(RegAux1,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDAUX1,RegAux1);break;
								case 2000 :wsprintf(RegAux1,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDAUX1,RegAux2);break;
								
								default   :MessageBoxA(hwndDialog,"ERRORE","Error 8",MB_OK);break;
							}
		
			}
			else 
			{
				GetVersion();
				wsprintf(RegEax,"%X",RegAppoggio1D);SetDlgItemText(hwndDialog,IDEAX,RegEax);
				wsprintf(RegEdx,"%X",RegAppoggio2D);SetDlgItemText(hwndDialog,IDEDX,RegEdx);
			}
		
			SetFlag(1);
	}
			return 1;
		}
	}
}
	/*<---------------------------------------------------------------------->*/
/*<---------------------------------------------------------------------->*/
/*<---------------------------------------------------------------------->*/
